<template>
  <app-header>
    <button @click="$router.go(-1)">
      <v-icon color="white" aria-hidden="false"> mdi-chevron-left </v-icon>
    </button>
  </app-header>
  <div class="user">
    <template v-if="user">
      <div class="container">
        <div class="user-profile">
          <div
            class="user-profile__photo"
            :style="{
              background: `url(${
                user.avatar
                  ? user.avatar.url.full_size
                  : require('../../assets/splash.svg')
              }) no-repeat center center`,
            }"
          />
          <div class="user-profile__info">
            <h3>{{ user.name }}</h3>
            <p>{{ user.age }} лет</p>
            <span>Уровень: {{ user.level }}</span>
          </div>
        </div>
        <div class="user-description">
          {{ user.description }}
        </div>
      </div>
      <div class="user-actions">
        <v-btn color="blue" variant="contained-flat" size="default">
          Добавить
        </v-btn>
      </div>
      <div class="container" v-if="events">
        <div class="user-events">
          <h3>События {{ user.name }}</h3>
          <div class="user-list">
            <event-preview
              :event="event"
              v-for="event in events"
              :key="event.id"
            />
          </div>
        </div>
      </div>
    </template>
    <div class="user-loader" v-else>
      <app-loader label="Загружаем информацию" />
    </div>
  </div>
</template>

<script>
import AppHeader from "@/components/AppHeader";
import { mapActions } from "vuex";
import AppLoader from "@/components/AppLoader";
import EventPreview from "@/components/EventPreview";
export default {
  name: "UserView",
  components: { EventPreview, AppLoader, AppHeader },

  data() {
    return {
      user: "",
      events: "",
    };
  },

  methods: {
    ...mapActions({
      loadUserInformation: "users/loadUserInformation",
      loadUserEvents: "users/loadUserEvents",
    }),
  },

  mounted() {
    this.loadUserInformation(this.$route.params.id)
      .then((response) => {
        this.user = response.data.data;
      })
      .catch(() => {
        this.$router.push({ name: "Profile" });
      });
    this.loadUserEvents(this.$route.params.id).then((response) => {
      this.events = response.data.data;
    });
  },
};
</script>

<style scoped lang="scss">
.user {
  max-width: 425px;
  margin: 0 auto;
  padding: 0 0 64px;
  &-loader {
    margin: 45% 0 0;
    display: flex;
    align-items: center;
    justify-content: center;
  }
  .container {
    background: $white;
    &:nth-child(3) {
      margin: 0 0 ($base-space * 4);
    }
  }

  &-profile {
    padding: $base-space * 4;
    display: grid;
    grid-template-columns: 100px 1fr;
    grid-gap: $base-space * 4;
    align-items: center;
    &__photo {
      height: 100px;
      background-size: cover !important;
    }
    &__info {
      > h3 {
        font-weight: 500;
        font-size: 20px;
        line-height: 18px;
        color: #212121;
        margin: 0 0 $base-space * 2;
      }
      > p {
        margin: 0 0 $base-space * 2;
        font-weight: 400;
        font-size: 12px;
        line-height: 18px;
        color: rgba(33, 33, 33, 0.6);
      }
      > span {
        display: block;
        font-style: normal;
        font-weight: 500;
        font-size: 14px;
        line-height: 18px;
        color: #666666;
      }
    }
  }
  &-description {
    padding: 0 $base-space * 4 $base-space * 4;
    font-style: normal;
    font-weight: 400;
    font-size: 12px;
    line-height: 18px;
    color: rgba(33, 33, 33, 0.6);
  }
  &-actions {
    width: 90%;
    margin: $base-space * 4 auto;
    display: grid;
    grid-template-columns: repeat(1, 1fr);
    grid-gap: $base-space * 4;
  }
  &-events {
    padding: $base-space * 4;
    > h3 {
      font-weight: 500;
      font-size: 14px;
      line-height: 18px;
      color: #5c5c5c;

      margin: 0 0 $base-space * 4;
    }
  }
  &-friends {
    padding: $base-space * 4;
    > h3 {
      font-weight: 500;
      font-size: 14px;
      line-height: 18px;
      color: #5c5c5c;

      margin: 0 0 $base-space * 4;
    }
  }
  &-list {
    width: 100%;
    display: flex;
    overflow-x: auto;
    flex-flow: row;
    grid-gap: $base-space * 2;
    &::-webkit-scrollbar {
      display: none;
    }
  }
}
</style>
